# Generated by Django 3.2.12 on 2022-09-21 13:26

from datetime import datetime

from django.db import migrations

CONFIG_SECRETS = {
    "rpc_shared_secret": "rpc-shared",
    "omapi_key": "omapi-key",
    "maas_auto_ipmi_k_g_bmc_key": "ipmi-k_g-key",
}


def move_secrets(apps, schema_editor):
    Config = apps.get_model("maasserver", "Config")
    Secret = apps.get_model("maasserver", "Secret")

    now = datetime.utcnow()
    configs = Config.objects.filter(name__in=CONFIG_SECRETS)
    Secret.objects.bulk_create(
        [
            Secret(
                path=f"global/{CONFIG_SECRETS[name]}",
                value={"secret": value},
                created=now,
                updated=now,
            )
            for name, value in configs.values_list("name", "value")
        ]
    )
    configs.delete()


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0281_secret_model"),
    ]

    operations = [migrations.RunPython(move_secrets)]
