# Generated by Django 3.2.12 on 2022-09-28 09:40

from datetime import datetime

from django.db import migrations

TLS_KEYS = ("tls_cacert", "tls_cert", "tls_key")


def move_tls_secrets(apps, schema_editor):
    Config = apps.get_model("maasserver", "Config")
    Secret = apps.get_model("maasserver", "Secret")

    configs = Config.objects.filter(name__in=TLS_KEYS)
    # ensure all keys are there
    secret_value = dict.fromkeys(TLS_KEYS)
    secret_value = {
        name.removeprefix("tls_"): value
        for name, value in configs.values_list("name", "value")
    }
    if any(secret_value.values()):
        now = datetime.utcnow()
        Secret.objects.create(
            path="global/tls",
            value=secret_value,
            created=now,
            updated=now,
        )

    configs.delete()


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0282_rpc_shared_secret_to_secret"),
    ]

    operations = [migrations.RunPython(move_tls_secrets)]
