# Generated by Django 3.2.12 on 2022-09-28 14:59

from datetime import datetime

from django.db import migrations

CONFIG_SECRETS = {
    "macaroon_private_key": "macaroon-key",
    "vcenter_password": "vcenter-password",
}


def move_secrets(apps, schema_editor):
    Config = apps.get_model("maasserver", "Config")
    Secret = apps.get_model("maasserver", "Secret")

    now = datetime.utcnow()
    configs = Config.objects.filter(name__in=CONFIG_SECRETS)
    Secret.objects.bulk_create(
        [
            Secret(
                path=f"global/{CONFIG_SECRETS[name]}",
                value={"secret": value},
                created=now,
                updated=now,
            )
            for name, value in configs.values_list("name", "value")
        ]
    )
    configs.delete()


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0283_migrate_tls_secrets"),
    ]

    operations = [migrations.RunPython(move_secrets)]
