# Generated by Django 3.2.12 on 2022-10-17 14:25

from binascii import b2a_hex
from datetime import datetime

from django.db import migrations


def to_hex(bin):
    return b2a_hex(bin).decode("ascii")


def migrate_rootkey_material(apps, schema_editor):
    RootKey = apps.get_model("maasserver", "RootKey")
    Secret = apps.get_model("maasserver", "Secret")

    root_keys = RootKey.objects.all()

    now = datetime.utcnow()
    Secret.objects.bulk_create(
        [
            Secret(
                path=f"rootkey/{key_id}/material",
                value={"secret": to_hex(material.tobytes())},
                created=now,
                updated=now,
            )
            for key_id, material in root_keys.values_list("id", "material")
        ]
    )

    root_keys.delete()


class Migration(migrations.Migration):

    dependencies = [
        ("maasserver", "0287_add_controller_info_vault_flag"),
    ]

    operations = [
        migrations.RunPython(migrate_rootkey_material),
        migrations.RemoveField(
            model_name="rootkey",
            name="material",
        ),
    ]
